VERSION 5.00
Begin VB.Form formPreCalEEPROM_Setup 
   Caption         =   "Pre Cal EEPROM Setup"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Help"
      Height          =   615
      Left            =   3120
      TabIndex        =   5
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Generate And Write EEPROM Table"
      Height          =   615
      Left            =   360
      TabIndex        =   4
      Top             =   2160
      Width           =   1335
   End
   Begin VB.TextBox gd2 
      Height          =   375
      Left            =   1560
      TabIndex        =   1
      Text            =   "Text2"
      Top             =   1320
      Width           =   1575
   End
   Begin VB.TextBox zd1 
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   720
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Zero Dac:"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   720
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Gain Dac:"
      Height          =   255
      Left            =   480
      TabIndex        =   2
      Top             =   1440
      Width           =   855
   End
End
Attribute VB_Name = "formPreCalEEPROM_Setup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
Call formPreCalEEPROM_Setup.zd1_Validate(False)
Call formPreCalEEPROM_Setup.gd2_Validate(False)
formPreCalEEPROM_Setup.Hide
End Sub

Private Sub Command2_Click()
MsgBox "This function will generate an EEPROM table that keeps gain and offset constant." + vbCrLf + "Using this feature allows you to do a pre-calibration test run WITHOUT using the test pin (i.e. test pin tied low)." + vbCrLf + "This method must be used in three wire modules." + vbCrLf + "Refer to the PGA309EVM users guide for further details regarding this feature."
End Sub

Private Sub Form_Load()
zd1 = formMain.txtZDAC.Text
gd2 = formMain.txtGDAC.Text
End Sub

Public Sub zd1_Validate(Cancel As Boolean)
    Dim UserVal, Lsb As Double
    Dim UserInp As Integer
    Dim Msg As String
    Cancel = False      ' presetting the value
    Lsb = VrefValue / CDbl(65536)
    UserVal = EngineeringVal(zd1.Text)
    If (UserVal > VrefValue) Or (UserVal < 0) Then
        Msg = "0.0 and " & Format(CStr(VrefValue), "#.000")
        Msg = "Value must be between " & Msg & " V/V" & _
            vbCrLf & "<OK> to set DAC to the closest value; <Cancel> to edit"
        UserInp = MsgBox(Msg, vbOKCancel, "Warning")
        If UserInp = vbCancel Then
            Cancel = True
        Else
            Cancel = False
        End If
    End If
    If Not Cancel Then 'if the value is OK or the user wants a fix - set the register bits
        If UserVal > (VrefValue - Lsb) Then UserVal = VrefValue - Lsb   'the max DAC value
        If UserVal < 0 Then UserVal = 0
        ZERO_DAC_PRE_CAL = CLng((65536) * UserVal / VrefValue) 'note 65536!
        zd1.Text = DisplayEngineering(VrefValue * ZERO_DAC_PRE_CAL / CDbl(65536))
    End If  'end value range checking
    'Call UpdateRegisterDisplay

End Sub

Public Sub gd2_Validate(Cancel As Boolean)
    Dim UserVal As Double
    Dim UserInp As Integer
    Dim Msg As String
    Cancel = False      'presetting
    UserVal = EngineeringVal(gd2.Text)
    If (UserVal > GDACmax) Or (UserVal < GDACmin) Then
        Msg = Format(CStr(GDACmin), "#.000") & " and " & Format(CStr(GDACmax), "#.000")
        Msg = "Value must be between " & Msg & " V/V" & _
            vbCrLf & "<OK> to set the closest value; <Cancel> to edit"
        UserInp = MsgBox(Msg, vbOKCancel, "Warning")
        If UserInp = vbCancel Then
            Cancel = True
        End If
    End If
    If Not Cancel Then  'if the value is OK or the user wants a fix - set the register bits
        If UserVal > GDACmax Then UserVal = GDACmax     'note: the max GDAC value = GDACmax, not GDACmax-1lsb
        If UserVal < GDACmin Then UserVal = GDACmin
        Gain_DAC_PRE_CAL = CLng((65535) * (UserVal - GDACmin) / (GDACmax - GDACmin))    'note 65535, not 65536!
        gd2.Text = DisplayEngineering(GDACmin + ((GDACmax - GDACmin) * Gain_DAC_PRE_CAL / CDbl(65535)))
    End If  'end value range checking
    'Call UpdateRegisterDisplay

End Sub
