Attribute VB_Name = "moduleMain"
Option Explicit
Public Const RegNumber = 9  ' used to be 11
Public Const MaxLookupTableLength = 17
Public Const GDACmax As Double = 1
Public Const GDACmin As Double = 0.333333
Public PGA309Registers(RegNumber) As Long
Public TalkMode As Integer  '0=I2C, 1=one-wire
Public LookupTable(MaxLookupTableLength + 1, 2) As Long
Public LookupTableLength As Integer  ' length of the lookup table
Public CurrentTableIndex As Integer  ' index of the currently edited entry
Public CurrentTableJ As Integer  ' J- index of the currently edited entry (0, 1 or 2)
'Public TableRowCount As Integer      'number of the displayed rows in the MSFlexGrid control
Public EEpromDisplayMode As Integer
Public RegLegend(RegNumber) As String
Public RegBitTips(RegNumber) As Variant
Public RegBitLabel(RegNumber) As Variant
Public VrefValue As Single
Public MaxLin As Single
Public EEPROMDataStream((MaxLookupTableLength + 1) * 6 + 15) As Byte ' array af memory data
'Public Pressed_Read_Vout
Public ZERO_DAC_PRE_CAL, Gain_DAC_PRE_CAL
Public Is_Table_Precal_Config As Boolean
Public LastMonthChecked As Double
Public LastYearChecked As Double
Public Main_Form_Loading As Boolean
Public done_bootup As Boolean
Public Sub Main()
    done_bootup = False

    frmSplash.Show
    frmSplash.Refresh
    Call GetSettings
    Main_Form_Loading = True
    Load formMain
    Main_Form_Loading = False
    Call InitPort
    SetConnectedStatus (False) 'clear the flag
    Delay (300)
    formMain.Show vbModeless
    Call DetectEVMBoard
    Unload frmSplash
    done_bootup = True
End Sub

Public Sub UpdateRegisterDisplay(Optional UpdateFlag As Boolean = True)
    Dim i As Integer    ' loop index
  With formMain.gridReg
    If .TextMatrix(1, 0) <> "0000" Then 'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "0000"
        .TextMatrix(1, 1) = " ADC Out(RO)"
        .TextMatrix(2, 0) = "0001"
        .TextMatrix(2, 1) = " ZeroDAC"
        .TextMatrix(3, 0) = "0010"
        .TextMatrix(3, 1) = " GainDAC"
        .TextMatrix(4, 0) = "0011"
        .TextMatrix(4, 1) = " * Ref&Lin"
        .TextMatrix(5, 0) = "0100"
        .TextMatrix(5, 1) = " * Gain,Vos,Cfg1"
        .TextMatrix(6, 0) = "0101"
        .TextMatrix(6, 1) = " * Cfg2,OverUnder"
        .TextMatrix(7, 0) = "0110"
        .TextMatrix(7, 1) = " * Cfg3 (ADC)"
        .TextMatrix(8, 0) = "0111"
        .TextMatrix(8, 1) = " OutEnbl Counter"
        .TextMatrix(9, 0) = "1000"
        .TextMatrix(9, 1) = " AlarmStatus(RO)"
'        .TextMatrix(10, 0) = "1110"
'        .TextMatrix(10, 1) = " Baud Cal(RO)"
'        .TextMatrix(11, 0) = "1111"
'        .TextMatrix(11, 1) = " ChipID(RO)"
'        .TextMatrix(12, 0) = ""
'        .TextMatrix(12, 1) = " Config Checksum"
        .TextMatrix(10, 0) = ""
        .TextMatrix(10, 1) = " Config Checksum"
    End If
    If UpdateFlag And (formMain.chkAutoSum = 1) Then
                'if checksum update is allowed
        Call CalcCheckSumRegisters
    End If
    For i = 0 To RegNumber
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(PGA309Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(PGA309Registers(i), 0, False)
    Next i
  End With
  If (formMain.tabRegRom.SelectedItem = formMain.tabRegRom.Tabs(2)) Then  'if the bit-toggle Reg details are visible
    Call formMain.ShowRegDetails       ' update those
  End If
  If dlgADCConfig.Visible = True Then
    Call dlgADCConfig.UpdateADCDialog
  End If
  If UpdateFlag And formMain.chkUpdateOnline.Value = 1 Then
            'if instant update is ON and allowed by flag
        formMain.timerBusAlive.Enabled = False   'disable the timer
        Call WritePGA
        Call formMain.chkKeepBusAlive_Click      'restore the timer
  End If
End Sub
            
            ' procedure to return a string with the
            ' binary value of the argument
Public Function DisplayBinary(Inval As Long) As String
    If Inval = 0 Then
        DisplayBinary = 0
    Else
        DisplayBinary = DisplayBinary(Fix(Inval / 2#)) & Format(Inval Mod 2, "0")
    End If
End Function

            ' displays the binary string of 8 LSBs of the argument
Public Function Display8Bit(Inval As Integer) As String
    Display8Bit = DisplayBinary(CLng(Inval))
    If Len(Display8Bit) > 9 Then
        Display8Bit = Right(Display8Bit, 8)
    Else
        While Len(Display8Bit) < 9
'            If Len(Display8Bit) = 4 Then Display8Bit = "_" & Display8Bit
            Display8Bit = "0" & Display8Bit
        Wend
    End If
End Function
            ' displays the binary string of 16 LSBs of the argument
Public Function Display16Bit(Inval As Long) As String
    Display16Bit = DisplayBinary(Inval)
    If Len(Display16Bit) > 16 Then
        Display16Bit = Right(Display16Bit, 16)
    Else
        While Len(Display16Bit) < 16
'            If ((Len(Display16Bit) Mod 4) = 0) Then Display16Bit = "_" & Display16Bit
            Display16Bit = "0" & Display16Bit
        Wend
    End If
    Display16Bit = Mid(Display16Bit, 1, 4) & "_" _
                 & Mid(Display16Bit, 5, 4) & "_" _
                 & Mid(Display16Bit, 9, 4) & "_" _
                 & Mid(Display16Bit, 13, 4)
End Function

Public Function BinStr2Val(inStrBin As String) As Variant
    If Len(inStrBin) = 0 Then  ' if the strin is empty
        BinStr2Val = 0
'    ElseIf Len(inStrBin) > 16 Then ' if the string is too long
'        BinStr2Val = BinStr2Val(Left(inStrBin, 16)) ' convert only left 16bits
    Else
        Select Case Right(inStrBin, 1)       'looking at LSB
        Case "1"      'if "1" - return 2*MSBs + 1
            BinStr2Val = 2 * BinStr2Val(Left(inStrBin, Len(inStrBin) - 1)) + 1
        Case "0"      'if "0" - return 2*MSBs
            BinStr2Val = 2 * BinStr2Val(Left(inStrBin, Len(inStrBin) - 1))
        Case Else     ' if not "1" nor "0" = ignore and continue with the rest of the string
            BinStr2Val = BinStr2Val(Left(inStrBin, Len(inStrBin) - 1))
        End Select
    End If
End Function

Public Function fromTwosCompliment(Inval As Long) As Long
            ' modified for 16-bit values
    If (Inval > 32767) Then     'processing 2's compliment value
        fromTwosCompliment = Inval - 65536
    Else
        fromTwosCompliment = Inval
    End If
End Function

Public Function toTwosCompliment(Inval As Long) As Long
            ' modified for 16-bit values
    If (Inval < 0) Then     'processing 2's compliment value
        toTwosCompliment = Inval + 65536
    Else
        toTwosCompliment = Inval
    End If
End Function

Public Function Lsb(Inval As Long) As Byte  'extracts the LSB from a long
    Dim Interim As Long
    Interim = Inval And &HFF 'LSB
    If Interim >= 0 Then
        Lsb = CByte(Interim)
    Else
        Lsb = CByte(Interim + 256)
    End If
End Function
Public Function Msb(Inval As Long) As Byte 'extracts the LSB from a long
    Dim Interim As Long
    Interim = (Inval And &HFF00) \ 256  'MSB
    If Interim >= 0 Then
        Msb = CByte(Interim)
    Else
        Msb = CByte(Interim + 256)
    End If
End Function

Public Function RegVal2Str(Inval As Long, Frmt As Integer, TwosComp As Boolean) As String
        ' inVal is the input number
        ' Frmt is the output format: 0 - binary, 1 - hex (4symbols), 2 - decimal
        ' TwosComp - 2's compliment flag, True/False
    Dim AdjVal As Long
    If TwosComp And (Inval < 0) Then    'processing 2's compliment value
        AdjVal = Inval + 65536
    Else
        AdjVal = Inval
    End If
    If (AdjVal < 0) Or (AdjVal > 65535) Then ' return empty str if input is out of limits
        RegVal2Str = ""
        Exit Function
    End If
    Select Case Frmt
    Case 0  ' binary
        RegVal2Str = Display16Bit(AdjVal)
    Case 1  ' hex
        RegVal2Str = Hex(AdjVal)    ' changed from Format(Hex(AdjVal), "0000")
        Do While Len(RegVal2Str) < 4
                ' add leading zeros
            RegVal2Str = "0" & RegVal2Str
        Loop
    Case 2 ' decimal (note: no 2's compliment in this case)
        RegVal2Str = Format(CStr(Inval), "#####0")
    End Select
End Function

Public Function DisplayEngineering(ByVal Inval As Double) As String
    Dim Suffix As String
    Dim Sign As Integer
    Sign = Sgn(Inval)
    Inval = Abs(Inval)
    If Inval > 1000000000000# Then
        Suffix = "T"
        Inval = Inval / 1000000000000#
    ElseIf Inval > 1000000000# Then
        Suffix = "G"
        Inval = Inval / 1000000000#
    ElseIf Inval > 1000000# Then
        Suffix = "M"
        Inval = Inval / 1000000#
    ElseIf Inval > 1000# Then
            Suffix = "K"
        Inval = Inval / 1000#
    ElseIf Inval > 1 Then
        Suffix = " "
    ElseIf Inval > 0.001 Then
        Suffix = "m"
        Inval = Inval / 0.001
    ElseIf Inval > 0.000001 Then
        Suffix = "u"
        Inval = Inval / 0.000001
    ElseIf Inval > 0.000000001 Then
        Suffix = "n"
        Inval = Inval / 0.000000001
    ElseIf Inval > 0.000000000001 Then
        Suffix = "p"
        Inval = Inval / 0.000000000001
    ElseIf Inval > 0.000000000000001 Then
        Suffix = "f"
        Inval = Inval / 0.000000000000001
    End If
    DisplayEngineering = Format(Sign * Inval, "##0.000") & Suffix
End Function

Public Function EngineeringVal(inStrDec As String) As Double
    Dim i As Integer
    Dim ch As String * 1
    Dim strNum As String
    If inStrDec = "" Then   'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    strNum = ""
    i = 0
    For i = 1 To Len(inStrDec)
        ch = Mid(inStrDec, i, 1)
        If (ch >= "0" And ch <= "9") Or ch = "." Or ch = "," _
            Or UCase(ch) = "E" Or ch = "+" Or ch = "-" Then
            strNum = strNum & ch
        Else
            Exit For    'break the loop if the char is not a digit
        End If
    Next i
    If strNum = "" Then     'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    EngineeringVal = CDbl(strNum)
    If i > Len(inStrDec) Then Exit Function 'exit if we reached
                                        'the end of the string
    Select Case ch
    Case "K", "k"
        EngineeringVal = EngineeringVal * 1000#
    Case "M"
        EngineeringVal = EngineeringVal * 1000000#
    Case "G", "t"
        EngineeringVal = EngineeringVal * 1000000000#
    Case "T", "t"
        EngineeringVal = EngineeringVal * 1000000000000#
    Case "m"
        EngineeringVal = EngineeringVal * 0.001
    Case "U", "u"
        EngineeringVal = EngineeringVal * 0.000001
    Case "N", "n"
        EngineeringVal = EngineeringVal * 0.000000001
    Case "P", "p"
        EngineeringVal = EngineeringVal * 0.000000000001
    Case "F", "f"
        EngineeringVal = EngineeringVal * 0.000000000000001
    End Select
End Function

Public Sub UpdatePhysDisplay(Optional UpdateFlag As Boolean = True)
'   (Cause As Integer)
        ' updates the text and combo controls in the "PGA309 Parameters" tab
    Dim i As Integer
    Call SetVrefDisplay
    Call SetRTIvos
    Call SetOverUnder
    Call SetVexc
    formMain.comboFrontGain.ListIndex = RegBits2Index(4, 8, 11)
    formMain.comboBackGain.ListIndex = RegBits2Index(4, 12, 14)
    formMain.chkDisableOverUnder.Value = RegBits2Index(5, 6, 6)
    formMain.chkExcEn.Value = RegBits2Index(3, 10, 10)
    formMain.chkRefEn.Value = RegBits2Index(3, 8, 8)
    formMain.txtZDAC.Text = DisplayEngineering(VrefValue * RegBits2Index(1, 0, 15) / CDbl(2 ^ 16))
    formMain.txtGDAC.Text = DisplayEngineering(GDACmin + ((GDACmax - GDACmin) * RegBits2Index(2, 0, 15) / CDbl(2 ^ 16)))
    Call UpdateTempADCoutput
    For i = 0 To 3  'setting the fault detect checkboxes
        formMain.chkErrDtct(i).Value = RegBits2Index(5, 8 + i, 8 + i)
    Next i
    Call SetLinCo
    Call UpdateRegisterDisplay(UpdateFlag)
End Sub

Public Sub UpdateTempADCoutput()
    formMain.txtADC(2).Text = Hex(PGA309Registers(0)) & " h"    'hex
    formMain.txtADC(1).Text = CStr(fromTwosCompliment(PGA309Registers(0)))    'decimal
    If RegBits2Index(6, 9, 9) = 1 Then  'if internal temp ADC mode is enbl
        Dim Resoln As Long
        Resoln = RegBits2Index(6, 0, 1)
        If Resoln = 0 Then  'adjusting the resolution scale factor
            Resoln = 2
        ElseIf Resoln = 1 Then
            Resoln = 4
        ElseIf Resoln = 2 Then
            Resoln = 8
        Else
            Resoln = 16
        End If
            'and display degC
        formMain.txtADC(0).Text = CStr(CDbl(fromTwosCompliment(PGA309Registers(0)) / Resoln)) & " degC"
    Else
        formMain.txtADC(0).Text = "----"
    End If
End Sub

Public Function IsDigit(inChar As String) As Boolean
    If inChar = "" Then
        IsDigit = False
    ElseIf (Asc(inChar) >= Asc("0") And Asc(inChar) <= Asc("9")) Or _
           (Asc(UCase(inChar)) >= Asc("A") And Asc(UCase(inChar)) <= Asc("F")) Then
            IsDigit = True
    Else
        IsDigit = False
    End If
End Function

Public Sub UpdateTableDisplay()
    Dim i, j As Integer
    Dim TableText As String
    If formMain.chkAutoSum.Value Then
        Call CalcCheckSumTable     ' calculate the checksum if "Auto CheckSum" is enabled
    End If
    TableText = ""
    For i = 0 To LookupTableLength + 1
                    ' looping through the table including the checksum value
                    ' and adding them to the display textbox
      For j = 0 To 2
           TableText = TableText & _
                    RegVal2Str(LookupTable(i, j), EEpromDisplayMode, True) & vbTab
      Next j
      TableText = TableText & vbNewLine
    Next i
    formMain.txtTableVal.Text = TableText
    formMain.LTableChanged = False  'reset the flag
    formMain.cmdLTApply.Enabled = False  'disable Apply and Discard buttons
    formMain.cmdLTCancel.Cancel = False
    formMain.cmdLTCancel.Enabled = False
End Sub
Public Sub CalcCheckSumTable()
    Dim i, j As Integer
    Dim Sum As Long
    Sum = 0
    For i = 0 To LookupTableLength
        For j = 0 To 2
            Sum = Sum + toTwosCompliment(LookupTable(i, j))
            'if there's a carryover bit - add it to the number from the left
            If Sum >= 65536 Then Sum = Sum - 65536
                        '(ChkSum And Val("&HFFFF")) + 1
        Next j
    Next i
            'make last byte sum with checksum to 0xFF
    LookupTable(LookupTableLength + 1, 0) = CInt("&h7FFF")  'setting the 7FFF for the table length limit
    LookupTable(LookupTableLength + 1, 1) = 0
    LookupTable(LookupTableLength + 1, 2) = fromTwosCompliment(65535 - (Sum + CInt("&h7FFF")))   ' the actual checksum value
End Sub

Public Sub CalcCheckSumRegisters()
    Dim Sum As Long
    Dim i As Integer
    Sum = ROM_Programmed
    For i = 3 To 6
        Sum = Sum + PGA309Registers(i)
            'if there's a carryover bit - add it to the number from the left
        If Sum >= 65536 Then Sum = Sum - 65536
                        '(ChkSum And Val("&HFFFF")) + 1
    Next i
            'make last byte sum wwith checksum to 0xFF
    PGA309Registers(RegNumber) = 65535 - Sum  ' the actual checksum value
End Sub

Public Sub SetRegLegend()
  Dim i As Integer
  RegLegend(0) = "AD[15:0] - Temperature ADC Output," & vbCrLf & _
    "Internal Temperature Mode: 12 bit + sign, right justified, Twos Complement data format" & vbCrLf & _
    "External Temperature Mode: 15 bit + sign, right justified, Twos Complement data format"
  RegLegend(1) = "ZD[15:0] - Zero DAC control, 16 bit unsigned data format"
  RegLegend(2) = "GD[15:0] - Gain DAC control, 16 bit unsigned data format"
  RegLegend(3) = "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "EXS - Linearization Adjust & Excitation Voltage (VEXC) Gain Select (Range1 or Range2)" & vbCrLf & _
    "0=Range 1 (-0.166VFB < Linearization DAC Range < +0.166VFB, VEXC Gain=0.83VREF)" & vbCrLf & _
    "1=Range 2 (-0.124VFB < Linearization DAC Range < +0.124VFB, VEXC Gain=0.52VREF)" & vbCrLf & _
    "EXEN - VEXC Enable: 1= Enable VEXC; 0=Disable VEXC" & vbCrLf & _
    "RS - Internal VREF Select: 0=4.096V; 1=2.5V" & vbCrLf & _
    "REN - Enable/Disable Internal VREF (Disable for External VREF - Connect External VREF to REFIN/REFOUT pin):" & vbCrLf & _
    "   0=External Reference (Disable Internal Reference); 1=Internal Reference (Enable Internal Reference)" & vbCrLf & _
    "LD[7:0] - Linearization DAC setting, 7 bit + sign"
  RegLegend(4) = "OWD - One-Wire Disable (only valid while VOUT is enabled, for use when PGM is connected to VOUT)" & vbCrLf & _
    "   1 = Disable; 0 = Enable" & vbCrLf & _
    "GO[2:0] - Output Amplifier Gain Select, 1-of-7 plus internal feedback disable" & vbCrLf & _
    "GI[3:0] - Front End PGA Gain Select, 1-of-8, and Input Mux Control" & vbCrLf & _
    "GI3=Input Mux Control" & vbCrLf & _
    "GI[2:0]=Gain Select" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "OS[4:0] - Coarse Offset Adjust on Front End PGA, 4 bit + sign; 1 LSB = VREF * 0.85e-3"
  RegLegend(5) = "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "CLK_CFG[1:0]: Clocking scheme for front-end PGA auto-zero and Coarse Offset DAC Chopping" & vbCrLf & _
    "EXTEN - Enable " + Chr(34) + "External Fault Comparator" + Chr(34) + " Group (INP_HI, INP_LO, INN_LO, INN_HI): 1=Enable; 0=Disable" & vbCrLf & _
    "INTEN - Enable " + Chr(34) + "Internal Fault Comparator" + Chr(34) + " Group (A2SAT_LO, A2SAT_HI, A1SAT_LO, A1SAT_HI, A3_VCM): 1=En; 0=Dsbl" & vbCrLf & _
    "EXTPOL- Selects VOUT output polarity when " + Chr(34) + "External Fault Comparator" + Chr(34) + " Group detects a fault (if EXTEN=1)" & vbCrLf & _
    "   1=Force VOUT high; 0=Force VOUT low" & vbCrLf & _
    "INTPOL- Selects VOUT output polarity when " + Chr(34) + "Internal Fault Comparator" + Chr(34) + " Group detects a fault (if INTEN=1)" & vbCrLf & _
    "   1=Force VOUT high; 0=Force VOUT low" & vbCrLf & _
    "OUEN - Over/Under-Scale Limit Enable: 1=Enable; 0=Disable" & vbCrLf & _
    "HL[2:0] - Over-Scale Threshold Select" & vbCrLf & _
    "LL[2:0] - Under-Scale Threshold Select"
  RegLegend(6) = "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "ADC2X - Temp ADC turbo mode(not for internal Temp Sense Mode): 0=1X speed (6ms typical); 1=2X speed (3ms typical)" & vbCrLf & _
    "ADCS - Start (restart) the Temperature ADC (one-shot if CEN=0); 0=No Start/Restart; 1=Start/Restart" & vbCrLf & _
    "ISEN - 7uA ITEMP Current source on pin TEMPin Enable: 1=Enable; 0=Disable" & vbCrLf & _
    "CEN - Continuous conversion mode of Temperature ADC: 1=Continuous; 0=Non-continuous (requires ADCS=1)" & vbCrLf & _
    "TEN - Internal Temperature Sensor ADC Mode: 1=Enable Internal mode; 0=Disable internal mode" & vbCrLf & _
    "AREN - Temperature ADC internal reference: 1=Enable (2.048V typical); 0=Disable (use external ADC reference - see RV[1:0])" & vbCrLf & _
    "RV[1:0] - Temperature ADC Reference Select (VREF, VEXC, VSA)" & vbCrLf & _
    "M[1:0] - Temperature ADC Input MUX select Select (TEMPin-GNDA, VEXC-TEMPin, VOUT-GNDA, VREF-TEMPin)" & vbCrLf & _
    "G[1:0] - Temperature ADC Gain Select (X1, X2, X4, X8)" & vbCrLf & _
    "R[1:0] - Temperature ADC Resolution (Conversion time) Select"
  RegLegend(7) = "Bits [15:12] - RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "DLY[3:0] - Temperature ADC conversion start delay" & vbCrLf & _
    "Temperature ADC begins conversion after DLY[3:0] x 10ms after valid write to this register." & vbCrLf & _
    "OEN[7:0] - Output Enable Counter for One-Wire Interface+VOUT Multiplexed mode"
  RegLegend(8) = "Bits [15:9] = RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "ALM[8:0] - Fault Monitor Comparator Outputs (1=Fault Condition)" & vbCrLf & _
    "ALM8 - A1SAT_HI" & vbCrLf & _
    "ALM7 - A1SAT_LO" & vbCrLf & _
    "ALM6 - A2SAT_HI" & vbCrLf & _
    "ALM5 - A2SAT_LO" & vbCrLf & _
    "ALM4 - A3_VCM" & vbCrLf & _
    "ALM3 - INN_HI" & vbCrLf & _
    "ALM2 - INN_LO" & vbCrLf & _
    "ALM1 - INP_HI" & vbCrLf & _
    "ALM0 - INP_LO"
'  RegLegend(9) = "BC[9:0] - Number of clock oscillator clock cycles in an 8-bit period"
'  RegLegend(10) = "ID[15:0] - ID Bits for factory identification/testing" & vbCrLf & _
    "A write of 0007hex to the Zero DAC Register (00001) will enable the ability to Read the ID Register"
  RegLegend(9) = "CS[15:0] - Checksum of the registers 011, 100, 101, 110" & vbCrLf & _
    "Note: This value is only stored in the EEPROM.  Editing is disabled if AutoChecksum is ON"

' now setting the individual bit tips
    RegBitTips(0) = Array("AD15", "AD14", "AD13", "AD12", "AD11", "AD10", "AD9", "AD8", "AD7", "AD6", "AD5", "AD4", "AD3", "AD2", "AD1", "AD0")
    RegBitTips(1) = Array("ZD15", "ZD14", "ZD13", "ZD12", "ZD11", "ZD10", "ZD9", "ZD8", "ZD7", "ZD6", "ZD5", "ZD4", "ZD3", "ZD2", "ZD1", "ZD0")
    RegBitTips(2) = Array("GD15", "GD14", "GD13", "GD12", "GD11", "GD10", "GD9", "GD8", "GD7", "GD6", "GD5", "GD4", "GD3", "GD2", "GD1", "GD0")
    RegBitTips(3) = Array("RFB", "RFB", "RFB", "RFB", "EXS- VEXC/LinDAC range select", "EXEN- VEXC/LinDAC Enable", _
        "RS- Internal VREF Select", "REN- Internal VREF Enable", "LD7- LinDAC", "LD6- LinDAC", "LD5- LinDAC", "LD4- LinDAC", _
        "LD3- LinDAC", "LD2- LinDAC", "LD1- LinDAC", "LD0- LinDAC")
    RegBitTips(4) = Array("OWD", "GO2- Output Amplifier Gain Select", "GO1- Output Amplifier Gain Select", "GO0- Output Amplifier Gain Select", _
        "GI3- Input Mux Control", "GI2- Front End PGA Gain Select", "GI1- Front End PGA Gain Select", "GI0- Front End PGA Gain Select", _
        "RFB", "RFB", "RFB", "OS4- Coarse Offset Adjust", "OS3- Coarse Offset Adjust", "OS2- Coarse Offset Adjust", "OS1- Coarse Offset Adjust", _
        "OS0- Coarse Offset Adjust")
    RegBitTips(5) = Array("RFB", "RFB", "CLK_CFG1", "CLK_CFG0", "EXTEN- Enable " + Chr(34) + "External Fault Comparator" + Chr(34) + " Group", _
        "INTEN- Enable " + Chr(34) + "Internal Fault Comparator" + Chr(34) + " Group", "EXTPOL- Selects VOUT polarity on External Fault", "INTPOL- Selects VOUT  polarity on Internal Fault", _
        "RFB", "OUEN- Over/Under-Scale Limit Enable", "HL2- Over-Scale Threshold", "HL1- Over-Scale Threshold", _
        "HL0- Over-Scale Threshold", "LL2- Under-Scale Threshold", "LL1- Under-Scale Threshold", "LL0- Under-Scale Threshold")
    RegBitTips(6) = Array("RFB", "RFB", "ADC_2X-Temp ADC turbo mode", "ADCS-Temp ADC single shot", "ISEN- Itemp enable", _
        "CEN- Temp ADC continuous mode", "TEN- Intenal Temp mode", "AREN- Temp ADC Reference select", "RV1- Temp ADC Reference select", _
        "RV0- Temp ADC Reference select", "M1- Temperature ADC Input MUX", "M0- Temperature ADC Input MUX", _
        "G1- Temperature ADC Input Gain", "G0- Temperature ADC Input Gain", "R1- Temperature ADC Resolution", "R0- Temperature ADC Resolution")
    RegBitTips(7) = Array("RFB", "RFB", "RFB", "RFB", "DLY3", "DLY2", "DLY1", "DLY0", "OEN7", "OEN6", "OEN5", "OEN4", "OEN3", "OEN2", "OEN1", "OEN0")
    RegBitTips(8) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "ALM8  A1SAT_HI", "ALM7  A1SAT_LO", "ALM6  A2SAT_HI", _
        "ALM5  A2SAT_LO", "ALM4  A3_VCM", "ALM3  INN_HI", "ALM2  INN_LO", "ALM1  INP_HI", "ALM0  INP_LO")
'    RegBitTips(9) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "BC9", "BC8", "BC7", "BC6", "BC5", "BC4", "BC3", "BC2", "BC1", "BC0")
'    RegBitTips(10) = Array("ID15", "ID14", "ID13", "ID12", "ID11", "ID10", "ID9", "ID8", "ID7", "ID6", "ID5", "ID4", "ID3", "ID2", "ID1", "ID0")
    RegBitTips(9) = Array("cs15", "cs14", "cs13", "cs12", "cs11", "cs10", "cs9", "cs8", "cs7", "cs6", "cs5", "cs4", "cs3", "cs2", "cs1", "cs0")
' now setting the individual bit Labels
    RegBitLabel(0) = Array("AD15", "AD14", "AD13", "AD12", "AD11", "AD10", "AD9", "AD8", "AD7", "AD6", "AD5", "AD4", "AD3", "AD2", "AD1", "AD0")
    RegBitLabel(1) = Array("ZD15", "ZD14", "ZD13", "ZD12", "ZD11", "ZD10", "ZD9", "ZD8", "ZD7", "ZD6", "ZD5", "ZD4", "ZD3", "ZD2", "ZD1", "ZD0")
    RegBitLabel(2) = Array("GD15", "GD14", "GD13", "GD12", "GD11", "GD10", "GD9", "GD8", "GD7", "GD6", "GD5", "GD4", "GD3", "GD2", "GD1", "GD0")
    RegBitLabel(3) = Array("RFB", "RFB", "RFB", "RFB", "EXS", "EXEN", "RS", "REN", "LD7", "LD6", "LD5", "LD4", "LD3", "LD2", "LD1", "LD0")
    RegBitLabel(4) = Array("OWD", "GO2", "GO1", "GO0", "GI3", "GI2", "GI1", "GI0", "RFB", "RFB", "RFB", "OS4", "OS3", "OS2", "OS1", "OS0")
    RegBitLabel(5) = Array("RFB", "RFB", "CLK_CFG1", "CLK_CFG0", "EXTEN", "INTEN", "EXTPOL", "INTPOL", "RFB", "OUEN", "HL2", "HL1", "HL0", "LL2", "LL1", "LL0")
    RegBitLabel(6) = Array("RFB", "RFB", "ADC_2X", "ADCS", "ISEN", "CEN", "TEN", "AREN", "RV1", "RV0", "M1", "M0", "G1", "G0", "R1", "R0")
    RegBitLabel(7) = Array("RFB", "RFB", "RFB", "RFB", "DLY3", "DLY2", "DLY1", "DLY0", "OEN7", "OEN6", "OEN5", "OEN4", "OEN3", "OEN2", "OEN1", "OEN0")
    RegBitLabel(8) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "ALM8", "ALM7", "ALM6", "ALM5", "ALM4", "ALM3", "ALM2", "ALM1", "ALM0")
'    RegBitlabel(9) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "BC9", "BC8", "BC7", "BC6", "BC5", "BC4", "BC3", "BC2", "BC1", "BC0")
'    RegBitlabel(10) = Array("ID15", "ID14", "ID13", "ID12", "ID11", "ID10", "ID9", "ID8", "ID7", "ID6", "ID5", "ID4", "ID3", "ID2", "ID1", "ID0")
    RegBitLabel(9) = Array("cs15", "cs14", "cs13", "cs12", "cs11", "cs10", "cs9", "cs8", "cs7", "cs6", "cs5", "cs4", "cs3", "cs2", "cs1", "cs0")
    
End Sub

Public Sub InsertLookupTableEntry(EntryVal() As Long)
    Dim i As Integer
    Dim Msg, Style, Title, Help, Ctxt, Response, MyString
    Msg = "The lookup table is already full." & vbCrLf _
        & "Do you want to erase the last entry ?"   ' Define message.
    Style = vbYesNo + vbQuestion + vbDefaultButton2   ' Define buttons.
    Title = "Warning"   ' Define title.
    If (LookupTableLength + 1) >= MaxLookupTableLength Then
        Response = MsgBox(Msg, Style, Title)  'if the table is already full
        If Response = vbNo Then Exit Sub  ' if user chose No: exit
        LookupTableLength = MaxLookupTableLength - 1
    Else
        LookupTableLength = LookupTableLength + 1
    End If
    For i = LookupTableLength To CurrentTableIndex + 1 Step -1
        LookupTable(i, 0) = LookupTable(i - 1, 0)
        LookupTable(i, 1) = LookupTable(i - 1, 1)
        LookupTable(i, 2) = LookupTable(i - 1, 2)
    Next i
    LookupTable(CurrentTableIndex, 0) = EntryVal(0)
    LookupTable(CurrentTableIndex, 1) = EntryVal(2)
    LookupTable(CurrentTableIndex, 2) = EntryVal(2)
    Call UpdateTableDisplay  'updating the display in the main window
End Sub

Public Sub DeleteLookupTableEntry()
    Dim i As Integer
    Dim Msg, Style, Title, Help, Ctxt, Response, MyString
    Msg = "The lookup table is already empty."  ' Define message.
    Style = vbOKOnly + vbExclamation
    Title = "Warning"
    If LookupTableLength = -1 Then
        Response = MsgBox(Msg, Style, Title)  'if the table is already empty
            'do nothing else
    Else
        LookupTableLength = LookupTableLength - 1  'deleting the current entry
        If CurrentTableIndex > LookupTableLength And _
           CurrentTableIndex > 0 Then
            CurrentTableIndex = CurrentTableIndex - 1
        End If
        For i = CurrentTableIndex To LookupTableLength
            LookupTable(i, 0) = LookupTable(i + 1, 0)
            LookupTable(i, 1) = LookupTable(i + 1, 1)
            LookupTable(i, 2) = LookupTable(i + 1, 2)
        Next i
    End If
    Call UpdateTableDisplay  'updating the display in the main window
End Sub

Public Sub SetRegBits(Val, RegNum, BitLo, BitHi As Integer)
    ' the procedure sets or clears a range of bits in the register
    ' Val - the desired value (if it exceeds the 2^(BitHi-BitLo),
    ' only the LSB will get assigned)
    ' RegNum - the number of the register
    ' BitLo, BitHi - bit addr range (inclusive)
    Dim Mask, ShiftVal As Long
    Dim i As Integer
    Mask = 0
    For i = 0 To BitLo - 1
      Mask = Mask + 2 ^ i
    Next i
    For i = BitHi + 1 To 15
      Mask = Mask + 2 ^ i
    Next i
    ShiftVal = (Val * (2 ^ BitLo)) And (Not Mask)
    PGA309Registers(RegNum) = (PGA309Registers(RegNum) And Mask) _
        Or ShiftVal
End Sub

Public Function RegBits2Index(RegNum, BitLo, BitHi As Integer) As Long
    ' the function returns the extracted numerical value from
    '   a range of bits in the register
    ' RegNum - the number of the register
    ' BitLo, BitHi - bit addr range (inclusive)
    Dim i As Integer
    RegBits2Index = 0
    For i = BitLo To BitHi
        If (PGA309Registers(RegNum) And (2 ^ i)) <> 0 Then
            RegBits2Index = RegBits2Index + (2 ^ (i - BitLo))
        End If
    Next i
End Function

Public Sub SetRTIvos()
    'sets the values of offset in the combobox with reference to the Vref
    Dim i As Integer
    Dim Lsb As Single
    Lsb = VrefValue * 0.00085     ' / 1200
  With formMain.comboRTIvos
    For i = 0 To 7
        .List(i) = DisplayEngineering(i * Lsb)
    Next i
    For i = 8 To 15
        .List(i) = DisplayEngineering((i - 1) * Lsb)
    Next i
    For i = 16 To 23
        .List(i) = DisplayEngineering(-(i - 16) * Lsb)
    Next i
    For i = 24 To 31
        .List(i) = DisplayEngineering(-(i - 17) * Lsb)
    Next i
    .ListIndex = CInt(RegBits2Index(4, 0, 4))
  End With
End Sub
Public Sub SetOverUnder()
    'sets the values of Over/Under levels in the comboboxes with reference to the Vref
  With formMain.comboUnderScale
        .List(0) = DisplayEngineering(0.0254 * VrefValue)
        .List(1) = DisplayEngineering(0.0293 * VrefValue)
        .List(2) = DisplayEngineering(0.0352 * VrefValue)
        .List(3) = DisplayEngineering(0.0391 * VrefValue)
        .List(4) = DisplayEngineering(0.0449 * VrefValue)
        .List(5) = DisplayEngineering(0.0507 * VrefValue)
        .List(6) = DisplayEngineering(0.0547 * VrefValue)
        .List(7) = DisplayEngineering(0.0605 * VrefValue)
        .ListIndex = CInt(RegBits2Index(5, 0, 2))
        If RegBits2Index(5, 6, 6) = 0 Then
                ' if disable bit is set - disable Over/Under choices
            .Enabled = False
        Else
            .Enabled = True
        End If
  End With
  With formMain.comboOverScale
        .List(0) = DisplayEngineering(0.9707 * VrefValue)
        .List(1) = DisplayEngineering(0.9609 * VrefValue)
        .List(2) = DisplayEngineering(0.9395 * VrefValue)
        .List(3) = DisplayEngineering(0.916 * VrefValue)
        .List(4) = DisplayEngineering(0.9102 * VrefValue)
        .List(5) = DisplayEngineering(0.7324 * VrefValue)
        .List(6) = DisplayEngineering(0.5527 * VrefValue)
        .List(7) = "Reserved"     'DisplayEngineering(0.4531 * VrefValue)
        .ListIndex = CInt(RegBits2Index(5, 3, 5))
        If RegBits2Index(5, 6, 6) = 0 Then
                ' if disable bit is set - disable Over/Under choices
            .Enabled = False
        Else
            .Enabled = True
        End If
  End With
End Sub

Public Sub SetVexc()
    'sets the values of Excitation levels in the combobox with reference to the Vref
    With formMain.comboVexc
        .List(0) = DisplayEngineering(0.83 * VrefValue)
        .List(1) = DisplayEngineering(0.52 * VrefValue)
        .ListIndex = RegBits2Index(3, 11, 11)
        If RegBits2Index(3, 10, 10) = 0 Then
                ' if disable bit is set - disable excitation and lin choices
            .Enabled = False
            formMain.txtLinCoef.Enabled = False
        Else    ' if the user enabled the excitation
            .Enabled = True
            formMain.txtLinCoef.Enabled = True
            If .ListIndex = 0 Then
                MaxLin = 0.166      'sets
            Else
                MaxLin = 0.124
            End If
        End If
    End With
End Sub

Public Sub SetVrefDisplay()
  With formMain
    If RegBits2Index(3, 8, 8) = 1 Then   'if ref is enabled
        .comboRef.ZOrder 0   'show the combobox
        .comboRef.Move 4320, 480
        .comboRef.Enabled = True
        .txtVref.Enabled = False
        .comboRef.ListIndex = RegBits2Index(3, 9, 9)
        VrefValue = EngineeringVal(.comboRef.List(.comboRef.ListIndex))
        'save the value to recover later
    Else    ' if the user disabled the internal reference
        .txtVref.ZOrder 0 ' show the input textbox on the same place as combo
        .txtVref.Move 4320, 480
        .txtVref.Enabled = True
        .comboRef.Enabled = False
        VrefValue = EngineeringVal(.txtVref.Text)
    End If
  End With
End Sub

Public Sub SetLinCo()
    Dim LinCo As Double
    LinCo = MaxLin * RegBits2Index(3, 0, 6) / 127
    If RegBits2Index(3, 7, 7) = 1 Then LinCo = -LinCo
    formMain.txtLinCoef.Text = DisplayEngineering(LinCo)
End Sub

Public Function CreateDataStream() As Integer
    ' the function creates the byte datastream for EEPROM or to write to a file
    ' returns its length
    Dim i As Integer
                    ' create the command sequence for EEPROM
    EEPROMDataStream(0) = Lsb(ROM_Programmed)
    EEPROMDataStream(1) = Msb(ROM_Programmed)
    EEPROMDataStream(2) = 0       'LEAVING THE 4 bytes set to zero
    EEPROMDataStream(3) = 0
    EEPROMDataStream(4) = 0
    EEPROMDataStream(5) = 0
    For i = 3 To 6    'configuration registers 0011, 0100, 0101, 0110
        EEPROMDataStream(2 * i) = Lsb(PGA309Registers(i))    'LSB
        EEPROMDataStream(2 * i + 1) = Msb(PGA309Registers(i))  'MSB
    Next i
        'now the first checksum
    EEPROMDataStream(14) = Lsb(PGA309Registers(RegNumber))
    EEPROMDataStream(15) = Msb(PGA309Registers(RegNumber))
    For i = 0 To LookupTableLength + 1  'now the lookup table w/ 2nd checksum
        EEPROMDataStream(6 * i + 16) = Lsb(toTwosCompliment(LookupTable(i, 0))) 'LSB  temp index
        EEPROMDataStream(6 * i + 17) = Msb(toTwosCompliment(LookupTable(i, 0)))  'MSB
        EEPROMDataStream(6 * i + 18) = Lsb(toTwosCompliment(LookupTable(i, 1))) 'LSB ZERO dac
        EEPROMDataStream(6 * i + 19) = Msb(toTwosCompliment(LookupTable(i, 1)))  'MSB
        EEPROMDataStream(6 * i + 20) = Lsb(toTwosCompliment(LookupTable(i, 2))) 'LSB GAIN dac
        EEPROMDataStream(6 * i + 21) = Msb(toTwosCompliment(LookupTable(i, 2)))  'MSB
    Next i
    CreateDataStream = 6 * (i - 1) + 21
End Function

Sub Write_TextFile(path As String)
        'copied from Ed Rojas and slightly edited - MVI, 12.03.2003
    Dim j, i As Integer
    Dim FileNum As Integer
    Dim EEPROMDataLength As Integer
    Dim OutStr As String
    Dim HexOut As Boolean
    Dim Response As VbMsgBoxResult
    
    On Error GoTo ErrorHandler  'set error handling label
    FileNum = FreeFile
    HexOut = True
    Open path For Output As FileNum
    EEPROMDataLength = CreateDataStream()
    If HexOut Then
        Print #FileNum, "hex"
    Else
        Print #FileNum, "bin"
    End If
    Print #FileNum, "'Config Data"
    For j = 0 To 15 Step 2  '
        If Len(Hex(EEPROMDataStream(j + 1))) < 2 Then           'make sure there're 2 digits
            OutStr = "0" & Hex(EEPROMDataStream(j + 1))  'MSB
        Else
            OutStr = Hex(EEPROMDataStream(j + 1))  'MSB
        End If
        If Len(Hex(EEPROMDataStream(j))) < 2 Then             'make sure there're 2 digits
            OutStr = OutStr & "0" & Hex(EEPROMDataStream(j)) 'assigning the LSB
        Else
            OutStr = OutStr & Hex(EEPROMDataStream(j)) 'assigning the LSB
        End If
        Print #FileNum, OutStr
    Next j
    Print #FileNum, "'Lookup Table"
    For j = 16 To EEPROMDataLength Step 6
        OutStr = ""
        For i = 0 To 2 'looping through the 3 values of the lookup table
            If Len(Hex(EEPROMDataStream(j + 2 * i + 1))) < 2 Then           'make sure there're 2 digits
                OutStr = OutStr & "0" & Hex(EEPROMDataStream(j + 2 * i + 1))  'MSB
            Else
                OutStr = OutStr & Hex(EEPROMDataStream(j + 2 * i + 1))  'MSB
            End If
            If Len(Hex(EEPROMDataStream(j + 2 * i))) < 2 Then             'make sure there're 2 digits
                     'assigning the LSB
                OutStr = OutStr & "0" & Hex(EEPROMDataStream(j + 2 * i)) & vbTab
            Else
                OutStr = OutStr & Hex(EEPROMDataStream(j + 2 * i)) & vbTab
            End If
        Next i
        OutStr = OutStr & "'"
        Print #FileNum, OutStr
    Next j
    Close FileNum
    On Error GoTo 0 ' restore the error handling
    Response = MsgBox("The file " & vbCrLf & path & vbCrLf & _
    "has been succesfully saved", vbOKOnly, "PGA309 Designer's Kit") 'inform the user
    Exit Sub    'exit to avoid running an error handler
ErrorHandler:
        Response = MsgBox("Error writing file:" & vbCrLf & path & vbCrLf, _
            vbOKOnly + vbCritical, "PGA309 Designer's Kit") 'inform the user
        Err.Clear
        On Error GoTo 0 'restore the error handling
                ' and exit the sub
End Sub
Sub Read_TextFile(path As String)
        'copied from Ed Rojas and slightly edited - MVI, 12.03.2003
    Dim Msg, Title As String
    Dim Style As VbMsgBoxStyle
    Dim Response As VbMsgBoxResult
    Dim i As Integer
    Dim FileNum, Mode As Integer
    Dim Inval As Long
    Dim line_Read As String
    FileNum = FreeFile
    On Error GoTo ErrorHandlerRead
    Open path For Input As FileNum
    Seek #FileNum, 1    'start at the beginning of the file
    Input #FileNum, line_Read
    line_Read = Mid$(line_Read, 1, 3)
    Select Case line_Read
    Case "hex"
        Mode = 0
    Case "dec"
        Mode = 1 'not implemented
    Case Else
        Mode = 3 'not implemented
    End Select
    Inval = Read_TextWord(FileNum, Mode)   'reading the first word
    If Inval = -1 Then
        Msg = "Premature end of file. Read aborted"  ' Define message.
        Style = vbOKOnly + vbCritical       ' Define buttons.
        Title = "Error"   ' Define title.
        Response = MsgBox(Msg, Style, Title)  'if the table is already full
        Close FileNum
        Exit Sub  ' if user chose No: exit
    ElseIf Inval <> ROM_Programmed Then
        Msg = "The file doesn't appear to be a PGA309 config file." & vbCrLf _
            & "Do you still want to load the contents into the memory?"   ' Define message.
        Style = vbYesNo + vbQuestion + vbDefaultButton2   ' Define button   s.
        Title = "Warning"   ' Define title.
        Response = MsgBox(Msg, Style, Title)
        If Response = vbNo Then
            Close FileNum
            Exit Sub  ' if user chose No: exit
        End If
    End If
    Inval = Read_TextWord(FileNum, Mode) 'skip 2 words - they should be empty
    Inval = Read_TextWord(FileNum, Mode)
    For i = 3 To 6      ' read the config registers
        PGA309Registers(i) = Read_TextWord(FileNum, Mode) 'reading the word
        If EOF(FileNum) Then Exit For
    Next i
    PGA309Registers(RegNumber) = Read_TextWord(FileNum, Mode)  'config checksum
    LookupTableLength = -1
    For i = 0 To MaxLookupTableLength - 1    ' read the lookuptable
            'reading the temp index
        LookupTable(i, 0) = fromTwosCompliment(Read_TextWord(FileNum, Mode))
            'reading the zero val
        LookupTable(i, 1) = fromTwosCompliment(Read_TextWord(FileNum, Mode))
            'reading the gain val
        LookupTable(i, 2) = fromTwosCompliment(Read_TextWord(FileNum, Mode))
        If Not (EOF(FileNum)) And LookupTable(i, 0) <> &H7FFF Then 'if it's not the end of the lookup table yet
            LookupTableLength = LookupTableLength + 1
        Else    'if we read the whole thing
            Exit For
        End If
    Next i
    Close FileNum
    Call UpdatePhysDisplay(False)
    Call UpdateTableDisplay
    On Error GoTo 0 ' restore the error handling
    Response = MsgBox("The file " & vbCrLf & path & vbCrLf & _
    "has been succesfully loaded", vbOKOnly, "PGA309 Designer's Kit") 'inform the user
    Exit Sub    'exit to avoid running an error handler
ErrorHandlerRead:
        Response = MsgBox("Error reading file:" & vbCrLf & path & vbCrLf, _
            vbOKOnly + vbCritical, "PGA309 Designer's Kit") 'inform the user
        Err.Clear
        On Error GoTo 0 'restore the error handling
                ' and exit the sub
End Sub
Public Sub SetUpPreCalEEPROM()
    LookupTableLength = 0
            'reading the temp index
        LookupTable(0, 0) = 2048
            'reading the zero val
        LookupTable(0, 1) = ZERO_DAC_PRE_CAL
            'reading the gain val
        LookupTable(0, 2) = Gain_DAC_PRE_CAL
 
             'reading the temp index END OF LOOKUP TABLE
        LookupTable(1, 0) = 32767
            'reading the zero val END OF LOOKUP TABLE -- IGNORED
        LookupTable(1, 1) = 0
            'reading the CHECK SUM
        LookupTable(1, 2) = 1 '37274
  
 End Sub


Public Function Read_TextWord(FileNum As Variant, Mode As Integer) As Long
    'reads one 2-byte work from an open textfile (similar to I2CReadWord())
    ' mode" 0 - hex, 1 - decimal
    Static line_Read As String
    Static Count, Length As Integer
    Static notCR As Boolean
    Dim Word_done As Boolean
    Dim ValStr, charC As String
    Dim NumChar As Integer
    If EOF(FileNum) And Count > Length Then   'check if the file is finished
        Read_TextWord = -1
        Exit Function
    End If
    NumChar = 0
    Word_done = False
  Select Case Mode
  Case 0
    ValStr = "&H"
    Do 'collect first 2bytes Ms and Ls
        If Not (notCR) Then     'if new line needs to be fetched
            If EOF(FileNum) Then  ' unexpected EOF
                Read_TextWord = -1
                Exit Function
            Else
                Line Input #FileNum, line_Read
                Length = Len(line_Read)
                Count = 0
                notCR = True
            End If
        End If
        charC = Mid$(line_Read, Count + 1, 1)
        Count = Count + 1
        If IsDigit(charC) Then
                    ' if digit and not a leading Zero
            ValStr = ValStr & charC
            NumChar = NumChar + 1
        Else
            If NumChar > 0 Then Word_done = True
            If charC = "'" Then notCR = False   'if comment - go to next line
        End If
        If Word_done Then  'if we've encountered a non-digit after some digits
            Read_TextWord = CLng(ValStr)
            Word_done = True
            NumChar = 0
            ValStr = "&H"
        End If
        If Count > Length Then
            notCR = False
        End If
    Loop Until Word_done
  Case 1
        Input #FileNum, line_Read
        If Not (EOF(FileNum)) Then
            Read_TextWord = CLng(line_Read)
        Else
            Read_TextWord = -1
        End If
  Case Else
    Read_TextWord = -1    'only hex and dec read are implemented at the moment
  End Select
End Function

Public Function ExtractNextNum(ByRef InputStr As String) As String
        'extracts the next Number (bin, hex or decimal) from a string,
        'returns this and shifts the input string up to the next non-digit
        'any non-numerical symbols are taken as separator
    Dim i As Integer
    Dim Result, ThisChar As String
    Result = ""
    Do While Len(InputStr) > 0
        ThisChar = UCase(Left(InputStr, 1))
        If IsDigit(ThisChar) Or ThisChar = "_" Then
                ' if a digit or underscore
            Result = Result & ThisChar
        ElseIf Len(Result) > 0 Then
                'if the current character is not a digit
                'but the result is not empty anymore -> get out from the loop
            Exit Do
        ElseIf ThisChar = "'" Then
            Do      ' if comment char - skip to the next CR or LF
                ThisChar = Left(InputStr, 1)
                InputStr = Right(InputStr, Len(InputStr) - 1)
            Loop While Len(InputStr) > 0 And (ThisChar <> vbCr Or _
                    ThisChar <> vbLf Or ThisChar <> vbCrLf)
        End If
        InputStr = Right(InputStr, Len(InputStr) - 1)
                'shift the string to the left
    Loop
    ExtractNextNum = Result
End Function
