Attribute VB_Name = "moduleSerialIO"

'Public bitSetRate As String
Public HexNum(5) As Byte

Public Sub SerStartup()
Dim lp_counter
' AAK Fixed problem if you connect issue with extra ports from port expander Jun 01, 05
lp_counter = 0
    Do
        If CommTrue(PortNumber) Then ' IsboardThere Then
            Call formMain.fncInitializeComPort(BitRate, PortNumber)  'init the COM port
            Call VbSetCommTimeouts(Int(Val(BitRate)))
            Exit Do
        End If
        DoEvents
        lp_counter = lp_counter + 1
    Loop Until (PortNumber = NumberOfPorts + 1) Or (lp_counter = 1000)
End Sub

Public Sub OW_DetectBench()
            ' the routine tries to read from PGA309 and EEPROM on serial port
    Dim InValPGA, InValEEPROM As Long
    Dim Msg, Style, Title, Response
    formMain.MousePointer = vbHourglass ' change pointer to hourglass
            ' Reading the 2 bytes from the PGA309
    InValEEPROM = -1
    InValPGA = OW_ReadPGARegister(0)   'reading the first register
    If InValPGA = -1 Then
        Msg = "The PGA309 is not responding on 1-wire interface"  ' Define message.
        Style = vbOKOnly + vbCritical       ' Define buttons.
        Title = "Error"   ' Define title.
        Response = MsgBox(Msg, Style, Title)  'if the table is already full
        SetConnectedStatus (False)
    Else
        InValEEPROM = OW_ReadEEPROMWord(0)    'reading the first word from EEPROM
        If InValEEPROM = -1 Then
            Msg = "The EEPROM is not responding through PGA309 on 1-wire interface"  ' Define message.
            Style = vbOKOnly + vbCritical       ' Define buttons.
            Title = "Error"   ' Define title.
            Response = MsgBox(Msg, Style, Title)  'if the table is already full
            SetConnectedStatus (False)
        End If
    End If
    If InValPGA <> -1 And InValEEPROM <> -1 Then  'if both PGA309 and EEPROM
                                                  'are present
        Msg = "The PGA309 EVM is detected using One-Wire interface. "
        If InValEEPROM <> ROM_Programmed Then
            Msg = Msg & vbLf & "The EEPROM doesn't appear to be programmed for PGA309."
        End If
        Style = vbOKOnly + vbInformation    ' Define buttons.
        Title = "PGA309 EVM detected OK"   ' Define title.
        Response = MsgBox(Msg, Style, Title)  'if the table is already full
        SetConnectedStatus (True)
    End If
    formMain.MousePointer = 0 ' change mouse back to default
End Sub

Public Function OW_WritePGARegister(RegIndex As Integer) As Boolean
    Dim Read_Back As Long
    formMain.MousePointer = 11 ' change pointer to hourglass
    formMain.StatusBar.SimpleText = "Writing PGA309 register #" & CStr(RegIndex) & " through One-Wire. Please stand by."
' setting the register pointer
    HexNum(0) = &H55
    HexNum(1) = &H1
    HexNum(2) = Lsb(CLng(RegIndex))
    Call TransmitBuffer_serial(3)
' now send the register content
    HexNum(0) = &H55
    HexNum(1) = &H4
    HexNum(2) = Lsb(PGA309Registers(RegIndex))
    HexNum(3) = Msb(PGA309Registers(RegIndex))
    Call TransmitBuffer_serial(4)
    Delay (50) ' wait 50ms and read back the register for verification
    OW_WritePGARegister = True
                
    If RegIndex <> 7 Then      'verification read if this was not the VoutEnbl register
        Read_Back = OW_ReadPGARegister(RegIndex)
        If (Read_Back <> PGA309Registers(RegIndex)) And (RegIndex <> 6) Then
                Dim Msg, Style, Title, Response
                        ' error unless it's REG #6 : the ADC has probably changed its status
            Msg = "Error writing PGA309 register # " & Str(RegIndex) & " on 1-wire interface"
            Style = vbOKOnly + vbCritical       ' Define buttons.
            Title = "Error"   ' Define title.
            Response = MsgBox(Msg, Style, Title)
            OW_WritePGARegister = False
        End If
    End If
    formMain.StatusBar.SimpleText = "Board Communcation Idle"
    formMain.MousePointer = 0 ' change mouse back to default
End Function

Public Function OW_ReadPGARegister(RegIndex As Integer) As Long
                    'reads and returns the value of one PGA309 register
    formMain.MSComm1.InBufferCount = 0  'clear the recieve buffer
    formMain.MSComm1.InputLen = 7 ' bytes to read
' setting the register pointer
    HexNum(0) = &H55
    HexNum(1) = &H1
    HexNum(2) = Lsb(CLng(RegIndex))
    Call TransmitBuffer_serial(3)
' read the content
    HexNum(0) = &H55
    HexNum(1) = &H10
    Call TransmitBuffer_serial(2)
    OW_ReadPGARegister = ReceiveBuffer_serial(7) ' read 7 bytes - the full sequence
End Function

Public Function OW_WriteEEPROM(Optional UseReg As Boolean = True, Optional InArray As Variant = Null) As Boolean
        ' writes the EEPROM with either any bytes from the argument array or (if InArray is empty)
        ' generates the PGA309-compliant data set from the register and look-up table arrays
    Dim DataByte1 As Byte, DataByte2 As Byte
    Dim Ackn As Boolean
    Dim i As Integer, CurrAddr As Integer, EEPROMDataLength As Integer
    Dim ReadBack As Long
    formMain.MousePointer = 11 ' change pointer to hourglass
    formMain.StatusBar.SimpleText = "Writing EEPROM through One-Wire interface. Please stand by"
                    ' create the data sequence for EEPROM
    If UseReg Then
            'in the input is empty - create the data stream
        EEPROMDataLength = CreateDataStream()
    Else
        EEPROMDataLength = UBound(InArray)
    End If
        'now start the writing process 8 bytes at a time
    CurrAddr = 0
    Do While (CurrAddr <= EEPROMDataLength)
    ' start the writing loop
        If UseReg Then
                ' take the data from the PGA309-compliant array
            DataByte1 = EEPROMDataStream(CurrAddr)
            DataByte2 = EEPROMDataStream(CurrAddr + 1)
        Else    ' take the data from the input array
            DataByte1 = InArray(CurrAddr)
            If CurrAddr < EEPROMDataLength Then
                    'make sure we don't exceed the array length
                DataByte2 = InArray(CurrAddr + 1)
            Else    ' append a Zero to the end if the length is not even
                DataByte2 = 0
            End If
        End If
    
    ' setting the EEPROM address pointer
        HexNum(0) = &H55
        HexNum(1) = &H2
        HexNum(2) = Lsb(CLng(CurrAddr))
        HexNum(3) = Msb(CLng(CurrAddr)) And &H7
        Call TransmitBuffer_serial(4)
    ' now send the data
        HexNum(0) = &H55
        HexNum(1) = &H8
        HexNum(2) = DataByte1
        HexNum(3) = DataByte2
        Call TransmitBuffer_serial(4)
        Call Delay(60)      'wait 60ms for PGA309 and eeprom to finish
                            ' and the data to be latched back
                    'verification read
        ReadBack = OW_ReadEEPROMWord(CLng(CurrAddr))
        If ReadBack <> CLng(DataByte1) + 256 * CLng(DataByte2) Then
                Dim Msg, Style, Title, Response
                        ' Define message.
            Msg = "Error writing EEPROM address # " & Str(CurrAddr) & " on 1-wire interface"
            Style = vbOKOnly + vbCritical       ' Define buttons.
            Title = "Error"   ' Define title.
            Response = MsgBox(Msg, Style, Title)
            SetConnectedStatus (False)
            Exit Do
        Else
            SetConnectedStatus (True)
        End If
        CurrAddr = CurrAddr + 2
    Loop
        'NEW STUFF-- shuts off pull up after 1-wire talk apr 13, 05
     If TalkMode = 1 And OW_Vout_short Then
             Keep_EVM_Status = EVM_PortExp_Status
                                ' set P1='1'; P0='0'
             EVM_PortExp_Status = (EVM_PortExp_Status) And (254)   '!'
             Ackn = PCF_Write(False)     'execute w/o read back
               EVM_PortExp_Status = Keep_EVM_Status
    End If
    'END NEW STUFF apr 13, 05

    formMain.StatusBar.SimpleText = "Board Communcation Idle"
    formMain.MousePointer = 0 ' change mouse back to default
End Function
Public Function OW_WriteEEPROM2(Optional UseReg As Boolean = True, Optional InArray As Variant = Null) As Boolean
        ' writes the EEPROM with either any bytes from the argument array or (if InArray is empty)
        ' generates the PGA309-compliant data set from the register and look-up table arrays
    Dim DataByte1 As Byte, DataByte2 As Byte
    Dim Ackn As Boolean
    Dim i As Integer, CurrAddr As Integer, EEPROMDataLength As Integer
    Dim ReadBack As Long
    formMain.MousePointer = 11 ' change pointer to hourglass
    formMain.StatusBar.SimpleText = "Writing EEPROM through One-Wire interface. Please stand by"
                    ' create the data sequence for EEPROM
    If UseReg Then
            'in the input is empty - create the data stream
        EEPROMDataLength = CreateDataStream()
    Else
        EEPROMDataLength = UBound(InArray)
    End If
        'now start the writing process 8 bytes at a time
    CurrAddr = 0
    Do While (CurrAddr <= EEPROMDataLength)
    ' start the writing loop
        If UseReg Then
                ' take the data from the PGA309-compliant array
            DataByte1 = EEPROMDataStream(CurrAddr)
            DataByte2 = EEPROMDataStream(CurrAddr + 1)
        Else    ' take the data from the input array
            DataByte1 = InArray(CurrAddr)
            If CurrAddr < EEPROMDataLength Then
                    'make sure we don't exceed the array length
                DataByte2 = InArray(CurrAddr + 1)
            Else    ' append a Zero to the end if the length is not even
                DataByte2 = 0
            End If
        End If
    
    ' setting the EEPROM address pointer
        HexNum(0) = &H55
        HexNum(1) = &H2
        HexNum(2) = Lsb(CLng(CurrAddr))
        HexNum(3) = Msb(CLng(CurrAddr)) And &H7
        Call TransmitBuffer_serial(4)
    ' now send the data
        HexNum(0) = &H55
        HexNum(1) = &H8
        HexNum(2) = DataByte1
        HexNum(3) = DataByte2
        Call TransmitBuffer_serial(4)
        Call Delay(60)      'wait 60ms for PGA309 and eeprom to finish
                            ' and the data to be latched back
                    'verification read
        ReadBack = OW_ReadEEPROMWord2(CLng(CurrAddr))
        If ReadBack <> CLng(DataByte1) + 256 * CLng(DataByte2) Then
                Dim Msg, Style, Title, Response
                        ' Define message.
            Msg = "Error writing EEPROM address # " & Str(CurrAddr) & " on 1-wire interface"
            Style = vbOKOnly + vbCritical       ' Define buttons.
            Title = "Error"   ' Define title.
            Response = MsgBox(Msg, Style, Title)
            SetConnectedStatus (False)
            Exit Do
        Else
            SetConnectedStatus (True)
        End If
        CurrAddr = CurrAddr + 2
    Loop
        'NEW STUFF-- shuts off pull up after 1-wire talk apr 13, 05
     If TalkMode = 1 And OW_Vout_short Then
             Keep_EVM_Status = EVM_PortExp_Status
                                ' set P1='1'; P0='0'
             EVM_PortExp_Status = (EVM_PortExp_Status) And (254)   '!'
             Ackn = PCF_Write(False)     'execute w/o read back
               EVM_PortExp_Status = Keep_EVM_Status
    End If
    'END NEW STUFF apr 13, 05

    formMain.StatusBar.SimpleText = "Board Communcation Idle"
    formMain.MousePointer = 0 ' change mouse back to default
End Function


Public Function OW_ReadEEPROMWord(Addr As Byte) As Long
                    'reads and returns the value of one PGA309 register
    formMain.MSComm1.InBufferCount = 0  'clear the recieve buffer
    formMain.MSComm1.InputLen = 8 ' bytes to read
' setting the EEPROM address pointer
    HexNum(0) = &H55
    HexNum(1) = &H2
    HexNum(2) = Lsb(CLng(Addr))
    HexNum(3) = Msb(CLng(Addr)) And &H7
    Call TransmitBuffer_serial(4)
' read the content
    HexNum(0) = &H55
    HexNum(1) = &H20
    Call TransmitBuffer_serial(2)
    OW_ReadEEPROMWord = ReceiveBuffer_serial(8) 'read 8 bytes - the full sequence)
End Function
Public Function OW_ReadEEPROMWord2(Addr As Integer) As Long
                    'reads and returns the value of one PGA309 register
    formMain.MSComm1.InBufferCount = 0  'clear the recieve buffer
    formMain.MSComm1.InputLen = 8 ' bytes to read
' setting the EEPROM address pointer
    HexNum(0) = &H55
    HexNum(1) = &H2
    HexNum(2) = Lsb(CLng(Addr))
    HexNum(3) = Msb(CLng(Addr)) And &H7
    Call TransmitBuffer_serial(4)
' read the content
    HexNum(0) = &H55
    HexNum(1) = &H20
    Call TransmitBuffer_serial(2)
    OW_ReadEEPROMWord2 = ReceiveBuffer_serial(8) 'read 8 bytes - the full sequence)
End Function
Private Sub oldTransmitBuffer_serial(NumOfBytes As Integer)
'Dim ByteToSend(5) As Byte
Dim j As Integer
Dim Buffer As Variant

    If (timeGetTime - LastTransactionTime) > MAX3238Timeout Then
            ' if more than 20sec has elapsed since last port transaction
            ' call MAX3238 to start up, then proceed
        Call StartMAX3238
    End If
    
    Buffer = ""
    For j = 0 To NumOfBytes - 1
        Buffer = Buffer & Chr(HexNum(j))
    Next j
    formMain.MSComm1.Output = Buffer
End Sub
Private Sub TransmitBuffer_serial(NumOfBytes As Integer)
'Dim ByteToSend(5) As Byte
Dim j As Integer
Dim Buffer As Variant
ReDim OutByteArray(NumOfBytes - 1) As Byte

    If (timeGetTime - LastTransactionTime) > MAX3238Timeout Then
            ' if more than 20sec has elapsed since last port transaction
            ' call MAX3238 to start up, then proceed
        Call StartMAX3238
    End If
    For j = 0 To NumOfBytes - 1
        OutByteArray(j) = HexNum(j)
    Next j
    formMain.MSComm1.Output = OutByteArray
End Sub

Private Function ReceiveBuffer_serial(BytesToRead As Integer) As Variant
 Dim TryNum As Integer
 Dim DataIn As Variant
    TryNum = 0
    On Error Resume Next
'    formMain.MSComm1.InputLen = BytesToRead
    Do
        Delay (1 + 10 * fncOneByteDelay(BitRate)) 'delay 10 byte period +1ms
                        'to make sure PGA309 has enough time to get the data
                        'from EEPROM if needed
        TryNum = TryNum + 1
    Loop Until (formMain.MSComm1.InBufferCount >= BytesToRead) Or TryNum > 100
    DataIn = formMain.MSComm1.Input
    If LenB(DataIn) = BytesToRead Then
        If DataIn(BytesToRead - 4) = &H55 And (DataIn(BytesToRead - 3) = &H10 Or _
                DataIn(BytesToRead - 3) = &H20) Then
            'if the input buffer has the command  also
            'convert the input to a number
            ReceiveBuffer_serial = DataIn(BytesToRead - 1) * 256 + DataIn(BytesToRead - 2)
        Else        'if not - return an error
            ReceiveBuffer_serial = -1
        End If
    Else        'if not 11 characters received: return an error
        ReceiveBuffer_serial = -1
    End If
    formMain.MSComm1.InBufferCount = 0
    Err.Clear
    On Error GoTo 0
End Function


